<template>
  <div class="container">
    <div class="section">
      <div>
        <h5 class="title is-5">Location</h5>
        <div class="buttons is-justify-end">
          <button
            class="button is-primary"
            @click="creating = !creating"
          >
              <span class="icon">
                <i class="material-icons">add</i>
              </span>
            <span>Add</span>
          </button>
          <refresh-button :loading="fetching" @refresh="fetchData" />
        </div>
        <create-section
          v-if="creating"
          :loading.sync="fetching"
          @refresh="fetchData"
          @hide="creating = false"
        />
      </div>
      <table class="table is-fullwidth">
        <thead>
        <tr><th>Name</th><th /></tr>
        </thead>
        <tbody>
        <location-row
          v-for="location in locations"
          :key="location.id"
          :location="location"
          @delete="deleting = true; deleteTarget = $event"
        />
        </tbody>
      </table>
    </div>
    <delete-dialog
      v-if="deleting"
      :show.sync="deleting"
      :loading.sync="fetching"
      :id="deleteTarget.id"
      :name="deleteTarget.name"
      @refresh="fetchData"
    />
  </div>
</template>

<script lang="ts">
  import { Component, Vue } from 'vue-property-decorator';
  import { Repository, Location } from '@/modals/location';

  @Component<LocationListPage>({
    components: {
      CreateSection: () => import('@/components/location/CreateSection.vue'),
      DeleteDialog: () => import('@/components/location/DeleteDialog.vue'),
      LocationRow: () => import('@/components/location/LocationRow.vue'),
      RefreshButton: () => import('@/components/RefreshButton.vue'),
    },
  })
  export default class LocationListPage extends Vue {
    fetching: boolean = false;
    creating: boolean = false;
    deleting: boolean = false;
    deleteTarget: Location | null = null;

    locations: Location[] = [];

    mounted() {
      return this.fetchData();
    }

    fetchData() {
      this.fetching = true;
      return Repository.list()
        .then((locations) => {
          this.locations = locations;
          this.fetching = false;
        });
    }

    remove(location: Location) {
      this.deleting = true;
      this.deleteTarget = location;
    }
  }
</script>
